



\starttext

\startluacode
--make a list
local function make_mylist(s)
 thelist={}
 for i=1, 10 do
   thelist[i]= s
 end
 return thelist
end

local template = [[
numeric dx, dy;
dx = 2cm; dy = 0.53cm;
path b[];
for i=1 upto lua("mp.print(\#document.variables.numberslist)"):
  b[i] = unitsquare xscaled dx yscaled dy shifted (0, -(i-1)*dy); 
  draw b[i];
  label(lua("mp.quoted(document.variables.numberslist[" & decimal i & "])"), center b[i]);
endfor
]]


local function steps(n)
 for j=1,n do
    mylist = make_mylist(j)
    document.variables={numberslist=mylist,}
    context.metafun.start()
    context.metafun.delayed(template)
    context.metafun.stop()
    context.quad()
 end
end 

context.hbox(function() steps(3) end)

\stopluacode




\stoptext
